
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <malloc.h>
#include <sys/time.h>


int
main( int argc, char *argv[] )
{
	const int	nofElems = 64 * 1024 * 1024;
	const int	nofMoves = 10000000;
	
	int			elemSize = sizeof( float );
	
	float		*mem1, *mem2;
	int			*memRand1, *memRand2;
	int			i=0;
	
	float		speedML=0, speedMB=0;
	struct		timeval tv1, tv2;
	time_t		t1, t2, td=0;
	
	srand( 5 );
	
	// create random array
	memRand1 = (int*)malloc( nofMoves * sizeof(int) );
	memRand2 = (int*)malloc( nofMoves * sizeof(int) );
	
	for ( i=0; i<nofMoves; i++ )
	{
		memRand1[i] = rand() % nofElems;
		memRand2[i] = rand() % nofElems;
	}
	
	// allocate memory arrays
	mem1 = (float*)malloc( nofElems * elemSize );
	mem2 = (float*)malloc( nofElems * elemSize );
	
	for ( i=0; i<nofElems; i++ )
	{
		mem1[i] = rand();
		mem2[i] = rand();
	}
	
	// run the test
	gettimeofday( &tv1, NULL );
	
	for ( i=0; i<nofMoves; i++ )
	{
		mem1[ memRand1[i] ] = mem2[ memRand2[i] ];
	}

	gettimeofday( &tv2, NULL );
	
	// calculate time difference
	t1 = tv1.tv_sec*1000000 + tv1.tv_usec;
	t2 = tv2.tv_sec*1000000 + tv2.tv_usec;
	td = t2 - t1;
	
	speedML = ( (nofMoves) / (td/1000000.0) ) / (1024*1024.0);
	speedMB = speedML * sizeof(float) * 4;
	
	printf( "td = %d us, speed=%f MegaLoops/s, %f MB/s\n", (int)td, speedML, speedMB );
	
	// free memories
	free( mem1 );
	free( mem2 );
	
	free( memRand1 );
	free( memRand2 );
	
	return 0;
}


